﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PuferFishContracts.Enums;
using PuferFishContracts.Extensions;
using PuferFishContracts.Exceptions;
using PuferFishContracts.Infrastructure;

namespace PuferFishContracts.DataModels;

public class ShopProductDataModel(string shopId, string productId, int count) : IValidation
{
    public string ShopId { get; private set; } = shopId;

    public string ProductId { get; private set; } = productId;

    public int Count { get; private set; } = count;
    public void Validate()
    {
        if (ShopId.IsEmpty())
            throw new ValidationException("Field WarehouseId is empty");

        if (!ShopId.IsGuid())
            throw new ValidationException("The value in the field WarehouseId is not a unique identifier");

        if (ProductId.IsEmpty())
            throw new ValidationException("Field TourId is empty");

        if (!ProductId.IsGuid())
            throw new ValidationException("The value in the field ProductId is not a unique identifier");

        if (Count <= 0)
            throw new ValidationException("Field Count is less than or equal to 0");
    }
}
