﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PuferFishContracts.Extensions;
using PuferFishContracts.Exceptions;
using PuferFishContracts.Infrastructure;

namespace PuferFishContracts.DataModels;

public class SupplyProductDataModel(string supplyId, string productId, int count) : IValidation
{
    public string SupplyId { get; private set; } = supplyId;
    public string ProductId { get; private set; } = productId;
    public int Count { get; private set; } = count;
    public void Validate()
    {
        if (SupplyId.IsEmpty())
            throw new ValidationException("Field SupplyId is empty");
        if (!SupplyId.IsGuid())
            throw new ValidationException("The value in the field SupplyId is not a unique identifier");
        if (ProductId.IsEmpty())
            throw new ValidationException("Field ProductId is empty");
        if (!ProductId.IsGuid())
            throw new ValidationException("The value in the field ProductId is not a unique identifier");
        if (Count <= 0)
            throw new ValidationException("Field Count is less than or equal to 0");
    }
}
